Blame tests/cert-tests/krb5-test

Packit aea12f
#!/bin/sh
Packit aea12f
Packit aea12f
# Copyright (C) 2015 Red Hat, Inc.
Packit aea12f
#
Packit aea12f
# This file is part of GnuTLS.
Packit aea12f
#
Packit aea12f
# GnuTLS is free software; you can redistribute it and/or modify it
Packit aea12f
# under the terms of the GNU General Public License as published by the
Packit aea12f
# Free Software Foundation; either version 3 of the License, or (at
Packit aea12f
# your option) any later version.
Packit aea12f
#
Packit aea12f
# GnuTLS is distributed in the hope that it will be useful, but
Packit aea12f
# WITHOUT ANY WARRANTY; without even the implied warranty of
Packit aea12f
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Packit aea12f
# General Public License for more details.
Packit aea12f
#
Packit aea12f
# You should have received a copy of the GNU General Public License
Packit aea12f
# along with GnuTLS; if not, write to the Free Software Foundation,
Packit aea12f
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
Packit aea12f
Packit aea12f
#set -e
Packit aea12f
Packit aea12f
srcdir="${srcdir:-.}"
Packit aea12f
CERTTOOL="${CERTTOOL:-../../src/certtool${EXEEXT}}"
Packit aea12f
DIFF="${DIFF:-diff}"
Packit aea12f
OUTFILE=tmp-krb5name.pem
Packit aea12f
TMPLFILE=tmp-krb5name.tmpl
Packit aea12f
Packit aea12f
if ! test -x "${CERTTOOL}"; then
Packit aea12f
	exit 77
Packit aea12f
fi
Packit aea12f
Packit aea12f
export TZ="UTC"
Packit aea12f
Packit aea12f
. ${srcdir}/../scripts/common.sh
Packit aea12f
Packit aea12f
check_for_datefudge
Packit aea12f
Packit aea12f
if ! test -z "${VALGRIND}"; then
Packit aea12f
	ORIG_VALGRIND=${VALGRIND}
Packit aea12f
	VALGRIND="${LIBTOOL:-libtool} --mode=execute ${VALGRIND} --error-exitcode=3"
Packit aea12f
fi
Packit aea12f
Packit aea12f
# Note that in rare cases this test may fail because the
Packit aea12f
# time set using datefudge could have changed since the generation
Packit aea12f
# (if example the system was busy)
Packit aea12f
Packit aea12f
datefudge -s "2007-04-22" \
Packit aea12f
	"${CERTTOOL}" --generate-self-signed \
Packit aea12f
		--load-privkey "${srcdir}/data/template-test.key" \
Packit aea12f
		--template "${srcdir}/templates/template-krb5name.tmpl" \
Packit aea12f
		--outfile ${OUTFILE} 2>/dev/null
Packit aea12f
Packit aea12f
${DIFF} "${srcdir}/data/template-krb5name.pem" ${OUTFILE} >/dev/null 2>&1
Packit aea12f
rc=$?
Packit aea12f
Packit aea12f
# We're done.
Packit aea12f
if test "${rc}" != "0"; then
Packit aea12f
	echo "Test 1 failed"
Packit aea12f
	exit ${rc}
Packit aea12f
fi
Packit aea12f
Packit aea12f
# disable all parameters to valgrind, to prevent memleak checking on
Packit aea12f
# the following tests (negative tests which have leaks in the tools).
Packit aea12f
if ! test -z "${ORIG_VALGRIND}"; then
Packit aea12f
	VALGRIND=$(echo ${ORIG_VALGRIND}|cut -d ' ' -f 1)
Packit aea12f
	VALGRIND="${LIBTOOL:-libtool} --mode=execute ${VALGRIND} --error-exitcode=3"
Packit aea12f
fi
Packit aea12f
Packit aea12f
# Negative tests. Check against values which may cause problems
Packit aea12f
cp "${srcdir}/templates/template-krb5name.tmpl" ${TMPLFILE}
Packit aea12f
echo "krb5_principal = 'xxxxxxxxxxxxxx'" >>${TMPLFILE}
Packit aea12f
Packit aea12f
datefudge -s "2007-04-22" \
Packit aea12f
${VALGRIND} "${CERTTOOL}" --generate-self-signed \
Packit aea12f
		--load-privkey "${srcdir}/data/template-test.key" \
Packit aea12f
		--template ${TMPLFILE} \
Packit aea12f
		--outfile ${OUTFILE} 2>/dev/null
Packit aea12f
Packit aea12f
rc=$?
Packit aea12f
Packit aea12f
# We're done.
Packit aea12f
if test "${rc}" != "1"; then
Packit aea12f
	echo "Negative Test 1 failed"
Packit aea12f
	exit ${rc}
Packit aea12f
fi
Packit aea12f
Packit aea12f
cp "${srcdir}/templates/template-krb5name.tmpl" ${TMPLFILE}
Packit aea12f
echo "krb5_principal = 'comp1/comp2/comp3/comp4/comp5/comp6/comp7/comp8/comp9/comp10@REALM.COM'" >>${TMPLFILE}
Packit aea12f
Packit aea12f
datefudge -s "2007-04-22" \
Packit aea12f
${VALGRIND} "${CERTTOOL}" --generate-self-signed \
Packit aea12f
		--load-privkey "${srcdir}/data/template-test.key" \
Packit aea12f
		--template ${TMPLFILE} \
Packit aea12f
		--outfile ${OUTFILE} 2>/dev/null
Packit aea12f
Packit aea12f
rc=$?
Packit aea12f
Packit aea12f
# We're done.
Packit aea12f
if test "${rc}" != "1"; then
Packit aea12f
	echo "Negative Test 2 failed"
Packit aea12f
	exit ${rc}
Packit aea12f
fi
Packit aea12f
Packit aea12f
rm -f ${OUTFILE}
Packit aea12f
rm -f ${TMPLFILE}
Packit aea12f
Packit aea12f
exit 0